## ros-eloquent-rmw-connext-cpp 0.8.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rmw_connext_cpp)

set(CONNEXT_STATIC_DISABLE $ENV{CONNEXT_STATIC_DISABLE}
  CACHE BOOL "If Connext Static should be disabled.")

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)

find_package(connext_cmake_module REQUIRED)
find_package(Connext QUIET MODULE)
if(Connext_FOUND)
  find_package(Connext MODULE)
endif()
if(NOT Connext_FOUND OR CONNEXT_STATIC_DISABLE)
  ament_package()
  if(NOT Connext_FOUND)
    message(WARNING "Could not find RTI Connext - skipping '${PROJECT_NAME}'")
  else()
    message(STATUS "Connext static rmw implementation explicitly disabled - skipping '${PROJECT_NAME}'")
  endif()
  return()
endif()

find_package(rcutils REQUIRED)

find_package(rosidl_typesupport_connext_c)
if(NOT rosidl_typesupport_connext_c_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for Connext (rosidl_typesupport_connext_c) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rosidl_typesupport_connext_cpp)
if(NOT rosidl_typesupport_connext_cpp_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for Connext (rosidl_typesupport_connext_cpp) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_connext_shared_cpp REQUIRED)
find_package(rosidl_generator_c REQUIRED)
find_package(rosidl_generator_cpp REQUIRED)

include_directories(include)

ament_export_include_directories(include)
ament_export_dependencies(
  rcutils
  rmw
  rmw_connext_shared_cpp
  rosidl_generator_c
  rosidl_generator_cpp
  rosidl_typesupport_connext_c
  rosidl_typesupport_connext_cpp)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_connext_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_connext_cpp"
)

# generate code for raw data
set(_idl_pp "${Connext_DDSGEN}")
if(NOT "${Connext_DDSGEN_SERVER}" STREQUAL "")
  # use the code generator in server mode when available
  # because it speeds up the code generation step significantly
  set(_idl_pp "${Connext_DDSGEN_SERVER}")
endif()
set(generated_directory "${CMAKE_CURRENT_BINARY_DIR}/resources/generated")
file(MAKE_DIRECTORY ${generated_directory})
set(generated_files
  ${generated_directory}/connext_static_serialized_data.cxx
  ${generated_directory}/connext_static_serialized_data.h
  ${generated_directory}/connext_static_serialized_dataPlugin.cxx
  ${generated_directory}/connext_static_serialized_dataPlugin.h
  ${generated_directory}/connext_static_serialized_dataSupport.cxx
  ${generated_directory}/connext_static_serialized_dataSupport.h
)
add_custom_command(
  OUTPUT ${generated_files}
  COMMAND "${_idl_pp}" -language C++ -unboundedSupport "connext_static_serialized_data.idl" -d ${generated_directory}
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/resources"
  COMMENT "Generating serialized type support for RTI Connext (using '${_idl_pp}')"
  VERBATIM
)

# determine major version of Connext
find_file(connext_version_header "ndds_version.h"
  PATHS ${Connext_INCLUDE_DIRS}
  PATH_SUFFIXES "ndds"
  NO_DEFAULT_PATH)
if(NOT connext_version_header)
  message(FATAL_ERROR "Failed to find 'ndds/ndds_version.h' in '${Connext_INCLUDE_DIRS}'")
endif()
file(STRINGS "${connext_version_header}" connext_define_major_version LIMIT_COUNT 1 REGEX "#define RTI_DDS_VERSION_MAJOR  [0-9]+")
if("${connext_define_major_version}" STREQUAL "")
  message(FATAL_ERROR "Failed to find '#define RTI_DDS_VERSION_MAJOR' in '${connext_version_header}'")
endif()
string(REGEX REPLACE ".* ([0-9]+)" "\\1" connext_major_version "${connext_define_major_version}")

# patch the generate code for raw data
if("${connext_major_version}" LESS 6)
  set(patch_files_subdirectory "patch_files")
else()
  set(patch_files_subdirectory "patch_files_v6")
endif()
set(patch_files
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_data.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_data.h.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataPlugin.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataPlugin.h.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataSupport.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataSupport.h.patch
)
set(patched_directory "${CMAKE_CURRENT_BINARY_DIR}/resources/patched")
file(MAKE_DIRECTORY ${patched_directory})
set(patched_files
  ${patched_directory}/connext_static_serialized_data.cxx
  ${patched_directory}/connext_static_serialized_data.h
  ${patched_directory}/connext_static_serialized_dataPlugin.cxx
  ${patched_directory}/connext_static_serialized_dataPlugin.h
  ${patched_directory}/connext_static_serialized_dataSupport.cxx
  ${patched_directory}/connext_static_serialized_dataSupport.h
)
add_custom_command(
  OUTPUT ${patched_files}
  COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/bin/apply-patch.py" --input ${generated_files} --patch ${patch_files} --out ${patched_files}
  DEPENDS ${generated_files}
  COMMENT "Patching serialized type support for RTI Connext"
  VERBATIM
)

add_library(
  rmw_connext_cpp
  SHARED
  ${patched_files}
  src/connext_static_publisher_info.cpp
  src/connext_static_subscriber_info.cpp
  src/get_client.cpp
  src/get_participant.cpp
  src/get_publisher.cpp
  src/get_service.cpp
  src/get_subscriber.cpp
  src/identifier.cpp
  src/process_topic_and_service_names.cpp
  src/rmw_client.cpp
  src/rmw_compare_gid_equals.cpp
  src/rmw_count.cpp
  src/rmw_event.cpp
  src/rmw_get_gid_for_publisher.cpp
  src/rmw_get_implementation_identifier.cpp
  src/rmw_get_serialization_format.cpp
  src/rmw_guard_condition.cpp
  src/rmw_init.cpp
  src/rmw_logging.cpp
  src/rmw_node.cpp
  src/rmw_node_info_and_types.cpp
  src/rmw_node_names.cpp
  src/rmw_publish.cpp
  src/rmw_publisher.cpp
  src/rmw_request.cpp
  src/rmw_response.cpp
  src/rmw_serialize.cpp
  src/rmw_service.cpp
  src/rmw_service_names_and_types.cpp
  src/rmw_service_server_is_available.cpp
  src/rmw_subscription.cpp
  src/rmw_take.cpp
  src/rmw_topic_names_and_types.cpp
  src/rmw_trigger_guard_condition.cpp
  src/rmw_wait.cpp
  src/rmw_wait_set.cpp
  src/serialization_format.cpp)
ament_target_dependencies(rmw_connext_cpp
  "rcutils"
  "rmw"
  "rmw_connext_shared_cpp"
  "rosidl_generator_c"
  "rosidl_generator_cpp"
  "rosidl_typesupport_connext_c"
  "rosidl_typesupport_connext_cpp"
  "Connext")
target_include_directories(rmw_connext_cpp PUBLIC ${patched_directory})
ament_export_libraries(rmw_connext_cpp)

# Causes the visibility macros to use dllexport rather than dllimport
# which is appropriate when building the library but not consuming it.
target_compile_definitions(rmw_connext_cpp
  PRIVATE "RMW_CONNEXT_CPP_BUILDING_DLL")

# On Windows this adds the RMW_BUILDING_DLL definition.
# On Unix (GCC or Clang) it hides the symbols with -fvisibility=hidden.
configure_rmw_library(rmw_connext_cpp)

if(WIN32)
  target_compile_definitions(rmw_connext_cpp
    PRIVATE "_CRT_NONSTDC_NO_DEPRECATE")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_connext_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

get_rmw_connext_output_filter("rmw_connext_output_filter")
ament_index_register_resource("rmw_output_prefixes" CONTENT "${rmw_connext_output_filter}")

=== debian/changelog ===
ros-eloquent-rmw-connext-cpp (0.8.2-1bionic) bionic; urgency=high

  * Fix wrong error messages (#458 <https://github.com/ros2/rmw_connext/issues/458>) (#479 <https://github.com/ros2/rmw_connext/issues/479>)
  * Update maintainers (#468 <https://github.com/ros2/rmw_connext/issues/468>) (#471 <https://github.com/ros2/rmw_connext/issues/471>)
  * avoid using build time Connext library paths, determine them when downstream packages are built (#385 <https://github.com/ros2/rmw_connext/issues/385>) (#433 <https://github.com/ros2/rmw_connext/issues/433>)
  * Contributors: Alejandro Hernández Cordero, Dirk Thomas, Ivan Santiago Paunovic

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Fri, 04 Dec 2020 06:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.8.1-1bionic) bionic; urgency=high

  * CMAKE_SOURCE_DIR -> CMAKE_CURRENT_SOURCE_DIR (#378 <https://github.com/ros2/rmw_connext/issues/378>)
  * use return_loaned_message_from (#376 <https://github.com/ros2/rmw_connext/issues/376>)
  * Support localhost only communication (#373 <https://github.com/ros2/rmw_connext/issues/373>)
  * Zero copy api (#367 <https://github.com/ros2/rmw_connext/issues/367>)
  * update logic / patches to optionally support Connext 6 (#374 <https://github.com/ros2/rmw_connext/issues/374>)
  * assert that unmodified lines in the patch match the input (#371 <https://github.com/ros2/rmw_connext/issues/371>)
  * supress invalid syntax warning for macro call (#370 <https://github.com/ros2/rmw_connext/issues/370>)
  * Fix build error (#369 <https://github.com/ros2/rmw_connext/issues/369>)
  * update signature for added pub/sub options (#368 <https://github.com/ros2/rmw_connext/issues/368>)
  * Contributors: Brian Marchi, Dan Rose, Dirk Thomas, Karsten Knese, William Woodall, ivanpauno

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 23 Oct 2019 05:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.8.0-1bionic) bionic; urgency=high

  * speed up copy with memcpy (#366 <https://github.com/ros2/rmw_connext/issues/366>)
  * Implement get_actual_qos() for subscriptions (#358 <https://github.com/ros2/rmw_connext/issues/358>)
  * add missing qos setings in get_actual_qos() (#357 <https://github.com/ros2/rmw_connext/issues/357>)
  * Contributors: Jacob Perron, M. M, Neil Puthuff

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 25 Sep 2019 05:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.7.2-1bionic) bionic; urgency=high

  * Add missing get_serialized_message_size method. (#355 <https://github.com/ros2/rmw_connext/issues/355>)
  * Contributors: Michael Carroll

 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 20 May 2019 05:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.7.1-1bionic) bionic; urgency=high

  * Combine package name with type namespace in type support struct (#354 <https://github.com/ros2/rmw_connext/issues/354>)
  * Implement QoS: liveliness, deadline, lifespan (#352 <https://github.com/ros2/rmw_connext/issues/352>)
  * Stub out new allocation APIs. (#353 <https://github.com/ros2/rmw_connext/issues/353>)
  * Contributors: Devin Bonnie, Jacob Perron, Michael Carroll

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 08 May 2019 05:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.7.0-1bionic) bionic; urgency=high

  * Add function to get publisher actual qos settings (#350 <https://github.com/ros2/rmw_connext/issues/350>)
  * pass context to wait set and fini context (#343 <https://github.com/ros2/rmw_connext/issues/343>)
  * deduplicate code (#312 <https://github.com/ros2/rmw_connext/issues/312>)
  * Delete datareader on the subscriber and datawriter on the publisher, issue #330 <https://github.com/ros2/rmw_connext/issues/330> (#337 <https://github.com/ros2/rmw_connext/issues/337>)
  * Remove unnecessary argument name, issue #331 <https://github.com/ros2/rmw_connext/issues/331> (#336 <https://github.com/ros2/rmw_connext/issues/336>)
  * Make use of DDS namespace instead of DDS_ prefixed versions in global namespace (#328 <https://github.com/ros2/rmw_connext/issues/328>)
  * Fixed typo in comments and remove trailing spaces (#332 <https://github.com/ros2/rmw_connext/issues/332>)
  * remove debug print (#322 <https://github.com/ros2/rmw_connext/issues/322>)
  * Contributors: Johnny Willemsen, William Woodall, ivanpauno

 -- Dirk Thomas <dthomas@osrfoundation.org>  Sat, 13 Apr 2019 05:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.6.1-1bionic) bionic; urgency=high

  * Node graph impl (#313 <https://github.com/ros2/rmw_connext/issues/313>)
  * refactor to support init options and context (#308 <https://github.com/ros2/rmw_connext/issues/308>)
  * Add implementation of matching publisher/subscriber counts (#310 <https://github.com/ros2/rmw_connext/issues/310>)
  * reduce verbosity when Connext is not available (#311 <https://github.com/ros2/rmw_connext/issues/311>)
  * use uint8_t array (#309 <https://github.com/ros2/rmw_connext/issues/309>)
  * Contributors: Dirk Thomas, Karsten Knese, Michael Carroll, Ross Desmond, William Woodall

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 06 Dec 2018 06:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.6.0-1bionic) bionic; urgency=high

  * use new error handling API from rcutils (#306 <https://github.com/ros2/rmw_connext/issues/306>)
  * Fix lint warning from invalid escape sequences (#305 <https://github.com/ros2/rmw_connext/issues/305>)
  * Include node namespaces in get_node_names (#299 <https://github.com/ros2/rmw_connext/issues/299>)
  * add rmw_get_serialization_format (#298 <https://github.com/ros2/rmw_connext/issues/298>)
  * Contributors: Jacob Perron, Karsten Knese, Michael Carroll, William Woodall

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 16 Nov 2018 06:00:00 -0000

ros-eloquent-rmw-connext-cpp (0.5.1-1bionic) bionic; urgency=high

  * only deserialize when taken is true (#297 <https://github.com/ros2/rmw_connext/issues/297>)
  * Contributors: Karsten Knese

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 28 Jun 2018 05:00:00 -0000



=== debian/control ===
Source: ros-eloquent-rmw-connext-cpp
Section: misc
Priority: optional
Maintainer: Alejandro Hernandez Cordero <alejandro@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-eloquent-ament-cmake, ros-eloquent-ament-lint-auto, ros-eloquent-ament-lint-common, ros-eloquent-connext-cmake-module, ros-eloquent-rcutils, ros-eloquent-rmw, ros-eloquent-rmw-connext-shared-cpp, ros-eloquent-rosidl-cmake, ros-eloquent-rosidl-generator-c, ros-eloquent-rosidl-generator-cpp, ros-eloquent-rosidl-generator-dds-idl, ros-eloquent-rosidl-typesupport-connext-c, ros-eloquent-rosidl-typesupport-connext-cpp, rti-connext-dds-5.3.1, ros-eloquent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-eloquent-rmw-connext-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-ament-cmake, ros-eloquent-connext-cmake-module, ros-eloquent-rcutils, ros-eloquent-rmw, ros-eloquent-rmw-connext-shared-cpp, ros-eloquent-rosidl-cmake, ros-eloquent-rosidl-generator-c, ros-eloquent-rosidl-generator-cpp, ros-eloquent-rosidl-typesupport-connext-c, ros-eloquent-rosidl-typesupport-connext-cpp, rti-connext-dds-5.3.1, ros-eloquent-ros-workspace
Description: Implement the ROS middleware interface using RTI Connext static code generation in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent" \
		-DCMAKE_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-rmw-connext-cpp//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
